# -*- coding: utf-8 -*-
from setuphelpers import *
import json

bin_contains = "ClavierSetup"


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    api_url = "https://api.github.com/repos/guilryder/clavier-plus/releases"
    # ClavierSetup64.exe
    if control.architecture == "x64":
        arch_contains = ".exe"
    else:
        arch_contains = "32.exe"
    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = json.loads(wgets(api_url, proxies=proxies))
    found = False
    for releases in json_load:
        if found:
            break
        for download in releases["assets"]:
            if bin_contains.lower() in download["name"].lower() and arch_contains.lower() in download["name"].lower():
                download_url = download["browser_download_url"]
                version = releases["tag_name"].replace("release", "")
                latest_bin = download["name"]
                found = True
                break
    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)
    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)
        # Checking version from file
        version_from_file = get_version_from_binary(latest_bin)
        # if not version_from_file.startswith(version) and version_from_file != '':
        if Version(version_from_file) != Version(version) and version_from_file != "":
            print("Changing version to the version number of the binary")
            os.rename(latest_bin, bin_contains + version_from_file + bin_ends)
            version = version_from_file
        else:
            print("Binary file version corresponds to online version")
    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()
    # Deleting outdated binaries
    remove_outdated_binaries(version)
    # Validating update-package-sources
    return result
